//CHAMADA DINAMICA A DLL -> INPOUT32.DLL

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>	//Necessrio para: LoadLibrary(), GetProcAddress() e HINSTANCE.

//Declarao dos ponteiros para funo.
typedef short _stdcall (*PtrInp)(short EndPorta);
typedef void _stdcall (*PtrOut)(short EndPorta, short valor);

int main(int argc, char *argv[])
{
    HINSTANCE hLib;	//Instncia para a DLL inpout32.dll.
    PtrInp inportB;	//Instncia para a funo Imp32().
    PtrOut outportB;	//Instncia para a funo Out32().

    hLib = LoadLibrary("inpout32.dll");		//Carrega a DLL na memria.

    if(hLib == NULL)	//Verifica se houve erro.
    {
            printf("Erro. O arquivo inpout32.dll no foi encontrado.\n");
            printf("Eh necessario que o arquivo .dll esteja na mesma pasta deste programa!!\n"); 
            getch();
            return -1;
    }

    inportB = (PtrInp) GetProcAddress(hLib, "Inp32");	//Obtm o endereo da funo Inp32 contida na DLL.

    if(inportB == NULL)		//Verifica se houve erro.
    {
            printf("Erro. A funo Inp32 no foi encontrada.\n");
            getch();
            return -1;
    }

    outportB = (PtrOut) GetProcAddress(hLib, "Out32");	//Obtm o endereo da funo Out32 contida na DLL.

    if(outportB == NULL)	//Verifica se houve erro.
    {
            printf("Erro. A funo Out32 no foi encontrada.\n");
            getch();
            return -1;
    }
    FreeLibrary(hLib);		//Libera memria alocada pela DLL. Deve ser executado no fim do programa.   
}
